		.device at90s2313
		.nolist
		.include "2313def.inc"
		.list
		

		.cseg		
		.def	tmp0=r16		;temp
		.def	bck0=r17		;zalohovani registru pri vstupu do rutiny
		.def	cnt0=r18		;pomocny citac	
		.def	cnt1=r19		
		.def	d1time=r20		;cas pocitany na prvnim displeji
		.def	d2time=r21		;cas pocitany na druhem displeji
		.def	buzw0=r22		;reg. pro pocitani zpozdeni na pipak
		.def	buzw1=r23
			
		.def	status=r24		;pomocny status registr
		.def	dispblink=r25
		.def	w0=r26			;pom. reg pro cekaci smycku
		.def	w1=r27
		
		
		.equ	KCNT0=100
		.equ	KCNT1=60

		.equ	D1=5			;disp1
		.equ	D2=6			;disp2
		.equ	BUZZ=4			;pipak
		.equ	OUTT=3			;vystup

		.equ	PLUS=0
		.equ	DSET=1
		.equ	RSET=2

		.org	$0000
		rjmp	start
		.org	$0005
		rjmp	buzzer
		.org	$0006
		rjmp 	dispc	;pri krystalu 10.24mhz kazdych 12.5ms pro displej

;; ********** hlavni program **********
start:
		ldi		tmp0,RAMEND
		out		spl,tmp0
;; nastaveni I/O portu		
		ldi		tmp0,$FF
		out		ddrb,tmp0		;portb jako vystup na disp
		ldi		tmp0,$FF
		out		portb,tmp0		;vypnuti displeje

		ldi		tmp0,0b01111000	
		out		ddrd,tmp0		;portd - PD0-PD3 vstupni tlacitka
		ldi		tmp0,0b01101111
		out		portd,tmp0		;pripojit pull-up k tl.
		

;;nastaveni casovace T0 a preruseni
		ldi		tmp0,100
		out		tcnt1l,tmp0
		ldi		tmp0,255
		out		tcnt1h,tmp0

		ldi		tmp0,0b00000000	
		out		tccr1a,tmp0
		ldi		tmp0,0b00000010
		out		tccr1b,tmp0

		ldi		cnt0,KCNT0
		ldi 	tmp0,0b00000101	
		out		tccr0,tmp0		;citani impulzu krystalu s preddelickou f/1024
		ldi		tmp0,0b00000010
		out		timsk,tmp0		;povoleni irq od T0 a T1
		sei						;globalni povoleni irq
;;pocatecni nastaveni registru
		ldi		cnt0,KCNT0	
		ldi		buzw1,10

;;;; hlavni smycka		
res:	sbi		portd,BUZZ
		cbi		portd,OUTT
		in		tmp0,timsk
		andi	tmp0,0b01111111
		out		timsk,tmp0		;povoleni T1 - zapnuti pipaku

		ldi		cnt1,60
		ldi		status,0b00010110
		ldi		d1time,0		; prvotni cas do pocitani casu
		ldi		d2time,0		
main:	sbic	pind,PLUS		; inkrementace blikajiciho cisla
		rjmp	settl

		mov		tmp0,status
		andi	tmp0,0b00000011
		cpi		tmp0,0
		brne	incdd

		
		sbrc	status,2		; prepinani modu 0-99min nebo 0.0-9.9min
		rjmp	pc+4
		ldi		status,0b00010100
		ldi		cnt1,60			; prvotni pocitaci konstanty
		rjmp	pc+3		
		ldi		status,0b00101000
		ldi		cnt1,6	
		rjmp	main0
incdd:	rcall	incdtm			; inkrementace  zakladu casu
main0:	rcall	wloop		
		sbis	pind,PLUS
		rjmp	pc-1
		rcall	wloop

settl:	sbic	pind,DSET		;tlacitko set
		rjmp	restl
		rcall	wloop	
		mov		tmp0,status
		andi	tmp0,0b00000011
		cpi		tmp0,$0
		breq	stcnt
		dec		status
		rjmp	settl0		

stcnt:	ori		status,0b01000000	;spustit odpocet a blikani
		andi	status,0b11001111
		sbic	pind,RSET
		rjmp	pc-1
		rjmp	res
		
settl0:	sbis	pind,DSET		;cekani na uvolneni tlacitka
		rjmp	pc-1
		rcall	wloop

restl:	sbic	pind,RSET
		rjmp	main
		rjmp	res

incdtm:	sbrs	status,0
		rjmp	incd2
		inc		d1time
		cpi		d1time,10
		brne	incd2
		ldi		d1time,0		
incd2:	sbrs	status,1
		rjmp	outa
		inc		d2time
		cpi		d2time,10
		brne	outa
		ldi		d2time,0
outa:	ret

;;*****cek. na zakmity
wloop:	ldi		w0,255
wl1:	ldi		w1,255	
wl0:	dec		w1
		brne	wl0
		dec		w0
		brne	wl1
		ret

;; ********** obsluha preruseni od T0 **
dispc:	in		bck0,sreg		;zaloha priznaku
		push	tmp0
		;ldi		tmp0,131
		ldi		tmp0,156
		out		tcnt0,tmp0		;nastaveni dalsiho preruseni
	
		sbrs	status,6
		rjmp	tctrl0	
		cpi		d2time,0
		brne	tctrl0
		cpi		d1time,0
		brne	tctrl0

		ldi		status,0b00000011	
		cbi		portd,BUZZ
		in		tmp0,timsk
		ori		tmp0,0b10000000
		out		timsk,tmp0		;povoleni T1 - zapnuti pipaku
		sbi		portd,OUTT		;sepnuti vystupu
		

tctrl0:
				
		dec		cnt0
		brne	cntt
		ldi		cnt0,KCNT0		;tu se program zastavi kazdou sekundu
		sbrs	status,6
		rjmp	cntt		
		
		cpi		cnt1,0
		brne	decs0

		cpi		d1time,0
		brne	decs3
		ldi		d1time,10	
		dec		d2time
decs3:	dec		d1time

		sbrc	status,2		; prepinani modu 0-99min nebo 0.0-9.9min
		rjmp	pc+3	
		ldi		cnt1,6			; prvotni pocitaci konstanty
		rjmp	pc+2
		ldi		cnt1,60			

decs0:	dec		cnt1
decs1:		


;********* obsluha displeje ****
cntt:	inc		dispblink		;casovani blikani displeje		
		cpi		dispblink,45

		sbis	portd,D1			
		rjmp	setd2
		sbi		portd,D2		;zhasne D2
		brmi	shd1		
		ldi		tmp0,10
		sbrs	status,0
shd1:	mov		tmp0,d1time		
		rcall	showt			;poslat na portb d1time
		cbi		portd,D1		;rozsviti D1
		sbrs	status,2		;blikani d.t.
		rjmp	setd1
		sbrc	status,4
		rjmp	bld1	
		brmi	setd1
bld1:	in		tmp0,portb
		andi	tmp0,0b01111111
		out		portb,tmp0
		rjmp	setd1

setd2:	sbi		portd,D1		;zhasne D1		
		brmi	shd2
		ldi		tmp0,10
		sbrs	status,1
shd2:	mov		tmp0,d2time		;poslat na portb d1time
		rcall	showt			;na port posle data pro D2
		cbi		portd,D2		;rozsviti D2
		sbrs	status,3		;blikani d.t.
		rjmp	setd1
		sbrc	status,5
		rjmp	bld1
		brmi	setd1
		in		tmp0,portb
		andi	tmp0,0b01111111
		out		portb,tmp0
		rjmp	setd1
setd1:	cpi		dispblink,60
		brne	rreti
		ldi		dispblink,0
rreti:	dec		buzw1
		brne	reti0
		ldi		buzw1,30
reti0:	out		sreg,bck0		;obnoveni sreg	
		pop		tmp0	
		reti

;; ********* zobrazeni dat casovych registru na port
showt:	in		bck0,sreg		;zaloha priznaku
		ldi		zl,low(ADRDTAB)
		ldi		zh,high(ADRDTAB)	;neprima adresace DTAB		
ctn0:	cpi		tmp0,0
		breq	ctn1
		adiw	zl,2
		dec		tmp0
		rjmp	ctn0			;pocitani adresy prevodniku cisla v DTAB
ctn1:	lpm						;nahrani dat z DTAB do r0
		out 	portb,r0		;poslat na port	
		out		sreg,bck0		;zaloha priznaku
		ret

;; ********** obsluha preruseni od T1
buzzer: in		bck0,sreg
		cpi		buzw1,10
		brmi	buzzoff

		sbis	portd,BUZZ
		rjmp	lp10		
		cbi		portd,BUZZ
		rjmp	lp11				
lp10:   sbi  	portd,BUZZ
lp11:

buzzoff:ldi		tmp0,100
		out		tcnt1l,tmp0
		ldi		tmp0,255
		out		tcnt1h,tmp0
		out		sreg,bck0
		reti


;;prevodni tabulka cifer pro displej
DTAB:	.dw		0b10000001		;0
		.dw		0b11001111		;1
		.dw		0b10010010		;2
		.dw		0b10000110		;3
		.dw		0b11001100		;4
		.dw		0b10100100		;5
		.dw		0b10100000		;6
		.dw		0b10001111		;7
		.dw		0b10000000		;8
		.dw		0b10001100		;9
		.dw		0b11111111		;zhasnuti displeje

		.equ	ADRDTAB=(2*DTAB)
		

		.exit



